use glium::glutin::dpi::LogicalSize;
//use glium::glutin::window::Window as GlutinWindow;
//use imgui::Ui;

mod app;
use app::System;

mod storage;
use storage::Storage;

mod main_window;
use main_window::MainWindow;

mod ui_generic;

const INIT_SIZE: (f64, f64) = (640.0, 480.0);
const MIN_SIZE: (f64, f64) = (300.0, 250.0);

fn main() {
    let main_app = System::init("muh window", INIT_SIZE);

    main_app.display
        .gl_window()
        .window()
        .set_min_inner_size(Some(LogicalSize::new(MIN_SIZE.0, MIN_SIZE.1)));

    let mut main_window = MainWindow::init();

    let win_size = main_app.display.gl_window().window().inner_size();
    main_window.size = [
        win_size.width as f32,
        300.0
    ];

    let mut main_storage = Storage::init();

    main_storage.add_bpm_change(0, 120.0);
    main_storage.add_keyframe_channel(String::from("keyframe channel 0"));
    main_storage.add_keyframe_channel(String::from("keyframe channel 1"));
    main_storage.add_keyframe_channel(String::from("keyframe channel 2"));

    main_app.main_loop(move |_, ui, display| {
        main_window.build(ui, display, &mut main_storage);
    });
}
